Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3711)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3712)
@@ -5656,318 +5707,318 @@
         DO  m = 1, surf_usm_h%ns
 
-if (surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) then
-!
-!--        Obtain indices
-           i = surf_usm_h%i(m)            
-           j = surf_usm_h%j(m)
-           k = surf_usm_h%k(m)
-
-           DO  kw = nzb_wall, nzt_wall
-!
-!--           Calculate volumetric heat capacity of the soil, taking 
-!--           into account water content 
-              surf_usm_h%rho_c_total_green(kw,m) = (surf_usm_h%rho_c_green(kw,m) * (1.0_wp - swc_sat_h(kw,m)) &
-                                   + rho_c_water * swc_h(kw,m))
+           IF (surf_usm_h%frac(ind_pav_green,m) > 0.0_wp) THEN
+!
+!--           Obtain indices
+              i = surf_usm_h%i(m)            
+              j = surf_usm_h%j(m)
+              k = surf_usm_h%k(m)
    
-!
-!--           Calculate soil heat conductivity at the center of the soil
-!--           layers
-              lambda_h_green_sat = lambda_h_green_sm ** (1.0_wp - swc_sat_h(kw,m)) *    &
-                             lambda_h_water ** swc_h(kw,m)
+              DO  kw = nzb_wall, nzt_wall
+!
+!--              Calculate volumetric heat capacity of the soil, taking 
+!--              into account water content 
+                 surf_usm_h%rho_c_total_green(kw,m) = (surf_usm_h%rho_c_green(kw,m) * (1.0_wp - swc_sat_h(kw,m)) &
+                                      + rho_c_water * swc_h(kw,m))
+      
+!
+!--              Calculate soil heat conductivity at the center of the soil
+!--              layers
+                 lambda_h_green_sat = lambda_h_green_sm ** (1.0_wp - swc_sat_h(kw,m)) *    &
+                                lambda_h_water ** swc_h(kw,m)
+      
+                 ke = 1.0_wp + LOG10(MAX(0.1_wp,swc_h(kw,m)             &
+                      / swc_sat_h(kw,m)))
+      
+                 lambda_green_temp(kw) = ke * (lambda_h_green_sat - lambda_h_green_dry) +    &
+                                  lambda_h_green_dry
    
-              ke = 1.0_wp + LOG10(MAX(0.1_wp,swc_h(kw,m)             &
-                   / swc_sat_h(kw,m)))
+              ENDDO
    
-              lambda_green_temp(kw) = ke * (lambda_h_green_sat - lambda_h_green_dry) +    &
-                               lambda_h_green_dry
-
-           ENDDO
-
-
-!
-!--        Calculate soil heat conductivity (lambda_h) at the _stag level 
-!--        using linear interpolation. For pavement surface, the
-!--        true pavement depth is considered
-           DO  kw = nzb_wall, nzt_wall
-             surf_usm_h%lambda_h_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) )  &
-                                   * 0.5_wp
-           ENDDO
-!           surf_usm_h%lambda_h_green(nzt_wall+1,m) = lambda_green_temp(nzt_wall+1)           
-!--------------------------------------------------------------------------
-           
-           t_green_h(nzt_wall+1,m) = t_wall_h(nzb_wall,m)
+   
+!
+!--           Calculate soil heat conductivity (lambda_h) at the _stag level 
+!--           using linear interpolation. For pavement surface, the
+!--           true pavement depth is considered
+              DO  kw = nzb_wall, nzt_wall
+                surf_usm_h%lambda_h_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) )  &
+                                      * 0.5_wp
+              ENDDO
+
+              t_green_h(nzt_wall+1,m) = t_wall_h(nzb_wall,m)
 !
 !--        prognostic equation for ground/roof temperature t_green_h
-           gtend(:) = 0.0_wp
-           gtend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_total_green(nzb_wall,m)) *    &
-                                      ( surf_usm_h%lambda_h_green(nzb_wall,m) * &
-                                        ( t_green_h(nzb_wall+1,m)               &
-                                        - t_green_h(nzb_wall,m) ) *             &
-                                        surf_usm_h%ddz_green(nzb_wall+1,m)      &
-                                      + surf_usm_h%wghf_eb_green(m) ) *         &
-                                        surf_usm_h%ddz_green_stag(nzb_wall,m)
-           
-            DO  kw = nzb_wall+1, nzt_wall
-                gtend(kw) = (1.0_wp / surf_usm_h%rho_c_total_green(kw,m))             &
-                               * (   surf_usm_h%lambda_h_green(kw,m)            &
-                                  * ( t_green_h(kw+1,m) - t_green_h(kw,m) )     &
-                                  * surf_usm_h%ddz_green(kw+1,m)                &
-                               - surf_usm_h%lambda_h_green(kw-1,m)              &
-                                  * ( t_green_h(kw,m) - t_green_h(kw-1,m) )     &
-                                  * surf_usm_h%ddz_green(kw,m)                  &
-                                 ) * surf_usm_h%ddz_green_stag(kw,m)
-            ENDDO
-
-           t_green_h_p(nzb_wall:nzt_wall,m) = t_green_h(nzb_wall:nzt_wall,m)    &
-                                 + dt_3d * ( tsc(2)                             &
-                                 * gtend(nzb_wall:nzt_wall) + tsc(3)            &
-                                 * surf_usm_h%tt_green_m(nzb_wall:nzt_wall,m) )   
-
-          
+              gtend(:) = 0.0_wp
+              gtend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_total_green(nzb_wall,m)) *    &
+                                         ( surf_usm_h%lambda_h_green(nzb_wall,m) * &
+                                           ( t_green_h(nzb_wall+1,m)               &
+                                           - t_green_h(nzb_wall,m) ) *             &
+                                           surf_usm_h%ddz_green(nzb_wall+1,m)      &
+                                         + surf_usm_h%wghf_eb_green(m) ) *         &
+                                           surf_usm_h%ddz_green_stag(nzb_wall,m)
+              
+               DO  kw = nzb_wall+1, nzt_wall
+                   gtend(kw) = (1.0_wp / surf_usm_h%rho_c_total_green(kw,m))       &
+                                  * (   surf_usm_h%lambda_h_green(kw,m)            &
+                                     * ( t_green_h(kw+1,m) - t_green_h(kw,m) )     &
+                                     * surf_usm_h%ddz_green(kw+1,m)                &
+                                  - surf_usm_h%lambda_h_green(kw-1,m)              &
+                                     * ( t_green_h(kw,m) - t_green_h(kw-1,m) )     &
+                                     * surf_usm_h%ddz_green(kw,m)                  &
+                                    ) * surf_usm_h%ddz_green_stag(kw,m)
+               ENDDO
+   
+              t_green_h_p(nzb_wall:nzt_wall,m) = t_green_h(nzb_wall:nzt_wall,m)    &
+                                    + dt_3d * ( tsc(2)                             &
+                                    * gtend(nzb_wall:nzt_wall) + tsc(3)            &
+                                    * surf_usm_h%tt_green_m(nzb_wall:nzt_wall,m) )   
+   
+             
 !
 !--        calculate t_green tendencies for the next Runge-Kutta step
-           IF ( timestep_scheme(1:5) == 'runge' )  THEN
-               IF ( intermediate_timestep_count == 1 )  THEN
-                  DO  kw = nzb_wall, nzt_wall
-                     surf_usm_h%tt_green_m(kw,m) = gtend(kw)
-                  ENDDO
-               ELSEIF ( intermediate_timestep_count <                           &
-                        intermediate_timestep_count_max )  THEN
-                   DO  kw = nzb_wall, nzt_wall
-                      surf_usm_h%tt_green_m(kw,m) = -9.5625_wp * gtend(kw) +    &
-                                         5.3125_wp * surf_usm_h%tt_green_m(kw,m)
-                   ENDDO
-               ENDIF
-           ENDIF
-
-!--------------------------------------------------------------
-                DO  kw = nzb_wall, nzt_wall
-
-!
-!--                Calculate soil diffusivity at the center of the soil layers
-                   lambda_green_temp(kw) = (- b_ch * surf_usm_h%gamma_w_green_sat(kw,m) * psi_sat       &
-                                     / swc_sat_h(kw,m) ) * ( MAX( swc_h(kw,m),    &
-                                     wilt_h(kw,m) ) / swc_sat_h(kw,m) )**(           &
-                                     b_ch + 2.0_wp )
-
-!
-!--                Parametrization of Van Genuchten
-                   IF ( soil_type /= 7 )  THEN
-!
-!--                   Calculate the hydraulic conductivity after Van Genuchten 
-!--                   (1980)
-                      h_vg = ( ( (swc_res_h(kw,m) - swc_sat_h(kw,m)) / ( swc_res_h(kw,m) -    &
-                                 MAX( swc_h(kw,m), wilt_h(kw,m) ) ) )**(      &
-                                 surf_usm_h%n_vg_green(m) / (surf_usm_h%n_vg_green(m) - 1.0_wp ) ) - 1.0_wp  &
-                             )**( 1.0_wp / surf_usm_h%n_vg_green(m) ) / surf_usm_h%alpha_vg_green(m)
-
-
-                      gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( ( (1.0_wp +         &
-                                      ( surf_usm_h%alpha_vg_green(m) * h_vg )**surf_usm_h%n_vg_green(m))**(  &
-                                      1.0_wp - 1.0_wp / surf_usm_h%n_vg_green(m) ) - (        &
-                                      surf_usm_h%alpha_vg_green(m) * h_vg )**( surf_usm_h%n_vg_green(m)      &
-                                      - 1.0_wp) )**2 )                         &
-                                      / ( ( 1.0_wp + ( surf_usm_h%alpha_vg_green(m) * h_vg    &
-                                      )**surf_usm_h%n_vg_green(m) )**( ( 1.0_wp  - 1.0_wp     &
-                                      / surf_usm_h%n_vg_green(m) ) *( surf_usm_h%l_vg_green(m) + 2.0_wp) ) )
-
-!
-!--                Parametrization of Clapp & Hornberger
-                   ELSE
-                      gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( swc_h(kw,m)       &
-                                      / swc_sat_h(kw,m) )**(2.0_wp * b_ch + 3.0_wp)
-                   ENDIF
-
-                ENDDO
-
-!
-!--             Prognostic equation for soil moisture content. Only performed,
-!--             when humidity is enabled in the atmosphere
-                IF ( humidity )  THEN
-!
-!--                Calculate soil diffusivity (lambda_w) at the _stag level 
-!--                using linear interpolation. To do: replace this with
-!--                ECMWF-IFS Eq. 8.81
-                   DO  kw = nzb_wall, nzt_wall-1
-                     
-                      surf_usm_h%lambda_w_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) )  &
-                                        * 0.5_wp
-                      surf_usm_h%gamma_w_green(kw,m)  = ( gamma_green_temp(kw+1) + gamma_green_temp(kw) )    &
-                                        * 0.5_wp
-
-                   ENDDO
-
-!
-!
-!--                In case of a closed bottom (= water content is conserved), 
-!--                set hydraulic conductivity to zero to that no water will be 
-!--                lost in the bottom layer.
-                   IF ( conserve_water_content )  THEN
-                      surf_usm_h%gamma_w_green(kw,m) = 0.0_wp
-                   ELSE
-                      surf_usm_h%gamma_w_green(kw,m) = gamma_green_temp(nzt_wall)
-                   ENDIF     
-
-!--                The root extraction (= root_extr * qsws_veg / (rho_l     
-!--                * l_v)) ensures the mass conservation for water. The         
-!--                transpiration of plants equals the cumulative withdrawals by 
-!--                the roots in the soil. The scheme takes into account the 
-!--                availability of water in the soil layers as well as the root 
-!--                fraction in the respective layer. Layer with moisture below 
-!--                wilting point will not contribute, which reflects the 
-!--                preference of plants to take water from moister layers.
-
-!
-!--                Calculate the root extraction (ECMWF 7.69, the sum of 
-!--                root_extr = 1). The energy balance solver guarantees a 
-!--                positive transpiration, so that there is no need for an 
-!--                additional check.
-                   m_total = 0.0_wp
-                   DO  kw = nzb_wall, nzt_wall
-                       IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
-                          m_total = m_total + rootfr_h(kw,m) * swc_h(kw,m)
-                       ENDIF
-                   ENDDO  
-
-                   IF ( m_total > 0.0_wp )  THEN
-                      DO  kw = nzb_wall, nzt_wall
-                         IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
-                            root_extr_green(kw) = rootfr_h(kw,m) * swc_h(kw,m)      &
-                                                            / m_total
-                         ELSE
-                            root_extr_green(kw) = 0.0_wp
-                         ENDIF
-                      ENDDO
-                   ENDIF
-
-!
-!--                Prognostic equation for soil water content m_soil.
-                   tend(:) = 0.0_wp
-
-                   tend(nzb_wall) = ( surf_usm_h%lambda_w_green(nzb_wall,m) * (               &
-                            swc_h(nzb_wall+1,m) - swc_h(nzb_wall,m) )    &
-                            * surf_usm_h%ddz_green(nzb_wall+1,m) - surf_usm_h%gamma_w_green(nzb_wall,m) - ( &
-                               root_extr_green(nzb_wall) * surf_usm_h%qsws_veg(m)          &
-!                                + surf_usm_h%qsws_soil_green(m)
-                                  ) * drho_l_lv )             &
-                                 * surf_usm_h%ddz_green_stag(nzb_wall,m)
-
-                   DO  kw = nzb_wall+1, nzt_wall-1
-                      tend(kw) = ( surf_usm_h%lambda_w_green(kw,m) * ( swc_h(kw+1,m)          &
-                                - swc_h(kw,m) ) * surf_usm_h%ddz_green(kw+1,m)              &
-                                - surf_usm_h%gamma_w_green(kw,m)                               &
-                                - surf_usm_h%lambda_w_green(kw-1,m) * (swc_h(kw,m) -         &
-                                swc_h(kw-1,m)) * surf_usm_h%ddz_green(kw,m)                 &
-                                + surf_usm_h%gamma_w_green(kw-1,m) - (root_extr_green(kw)             &
-                                * surf_usm_h%qsws_veg(m) * drho_l_lv)                &
-                                ) * surf_usm_h%ddz_green_stag(kw,m)
-
-                   ENDDO
-                   tend(nzt_wall) = ( - surf_usm_h%gamma_w_green(nzt_wall,m)                  &
-                                           - surf_usm_h%lambda_w_green(nzt_wall-1,m)          &
-                                           * (swc_h(nzt_wall,m)             &
-                                           - swc_h(nzt_wall-1,m))           &
-                                           * surf_usm_h%ddz_green(nzt_wall,m)                &
-                                           + surf_usm_h%gamma_w_green(nzt_wall-1,m) - (       &
-                                             root_extr_green(nzt_wall)               &
-                                           * surf_usm_h%qsws_veg(m) * drho_l_lv  )   &
-                                     ) * surf_usm_h%ddz_green_stag(nzt_wall,m)             
-
-                   swc_h_p(nzb_wall:nzt_wall,m) = swc_h(nzb_wall:nzt_wall,m)&
-                                                   + dt_3d * ( tsc(2) * tend(:)   &
-                                                   + tsc(3) * surf_usm_h%tswc_h_m(:,m) )   
-   
-!
-!--                Account for dry soils (find a better solution here!)
-                   DO  kw = nzb_wall, nzt_wall
-                      IF ( swc_h_p(kw,m) < 0.0_wp )  swc_h_p(kw,m) = 0.0_wp
-                   ENDDO
-
-!
-!--                Calculate m_soil tendencies for the next Runge-Kutta step
-                   IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                      IF ( intermediate_timestep_count == 1 )  THEN
-                         DO  kw = nzb_wall, nzt_wall
-                            surf_usm_h%tswc_h_m(kw,m) = tend(kw)
-                         ENDDO
-                      ELSEIF ( intermediate_timestep_count <                   &
-                               intermediate_timestep_count_max )  THEN
-                         DO  kw = nzb_wall, nzt_wall
-                            surf_usm_h%tswc_h_m(kw,m) = -9.5625_wp * tend(kw) + 5.3125_wp&
-                                     * surf_usm_h%tswc_h_m(kw,m)
-                         ENDDO
-                      ENDIF
-                   ENDIF
-                ENDIF
-!--------------------------------------------------------------
-ENDIF
-           
-        ENDDO
-
-!
-!--     For vertical surfaces     
-        DO  l = 0, 3                              
-           DO  m = 1, surf_usm_v(l)%ns
-
-if (surf_usm_v(l)%frac(ind_pav_green,m).gt.0.0_wp) then
-  if (1.gt.2) then
-!
-!--           Obtain indices
-              i = surf_usm_v(l)%i(m)            
-              j = surf_usm_v(l)%j(m)
-              k = surf_usm_v(l)%k(m)
-
-              t_green_v(l)%t(nzt_wall+1,m) = t_wall_v(l)%t(nzb_wall,m)
-!
-!--           prognostic equation for green temperature t_green_v
-              gtend(:) = 0.0_wp
-              gtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_green(nzb_wall,m)) * &
-                                      ( surf_usm_v(l)%lambda_h_green(nzb_wall,m) * &
-                                        ( t_green_v(l)%t(nzb_wall+1,m)             &
-                                        - t_green_v(l)%t(nzb_wall,m) ) *           &
-                                        surf_usm_v(l)%ddz_green(nzb_wall+1,m)      &
-                                      + surf_usm_v(l)%wghf_eb(m) ) *               &
-                                        surf_usm_v(l)%ddz_green_stag(nzb_wall,m)
-            
-              DO  kw = nzb_wall+1, nzt_wall
-                 gtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_green(kw,m))          &
-                           * (   surf_usm_v(l)%lambda_h_green(kw,m)              &
-                             * ( t_green_v(l)%t(kw+1,m) - t_green_v(l)%t(kw,m) ) &
-                             * surf_usm_v(l)%ddz_green(kw+1,m)                   &
-                           - surf_usm_v(l)%lambda_h(kw-1,m)                      &
-                             * ( t_green_v(l)%t(kw,m) - t_green_v(l)%t(kw-1,m) ) &
-                             * surf_usm_v(l)%ddz_green(kw,m) )                   &
-                           * surf_usm_v(l)%ddz_green_stag(kw,m)
-              ENDDO
-
-              t_green_v_p(l)%t(nzb_wall:nzt_wall,m) =                              &
-                                   t_green_v(l)%t(nzb_wall:nzt_wall,m)             &
-                                 + dt_3d * ( tsc(2)                                &
-                                 * gtend(nzb_wall:nzt_wall) + tsc(3)               &
-                                 * surf_usm_v(l)%tt_green_m(nzb_wall:nzt_wall,m) )   
-
-!
-!--           calculate t_green tendencies for the next Runge-Kutta step
               IF ( timestep_scheme(1:5) == 'runge' )  THEN
                   IF ( intermediate_timestep_count == 1 )  THEN
                      DO  kw = nzb_wall, nzt_wall
-                        surf_usm_v(l)%tt_green_m(kw,m) = gtend(kw)
+                        surf_usm_h%tt_green_m(kw,m) = gtend(kw)
                      ENDDO
                   ELSEIF ( intermediate_timestep_count <                           &
                            intermediate_timestep_count_max )  THEN
                       DO  kw = nzb_wall, nzt_wall
-                         surf_usm_v(l)%tt_green_m(kw,m) =                          &
-                                     - 9.5625_wp * gtend(kw) +                     &
-                                       5.3125_wp * surf_usm_v(l)%tt_green_m(kw,m)
+                         surf_usm_h%tt_green_m(kw,m) = -9.5625_wp * gtend(kw) +    &
+                                            5.3125_wp * surf_usm_h%tt_green_m(kw,m)
                       ENDDO
                   ENDIF
               ENDIF
-endif
-
-DO  kw = nzb_wall, nzt_wall+1
-t_green_v(l)%t(kw,m) = t_wall_v(l)%t(nzb_wall,m)
-ENDDO
+
+              DO  kw = nzb_wall, nzt_wall
+
+!
+!--              Calculate soil diffusivity at the center of the soil layers
+                 lambda_green_temp(kw) = (- b_ch * surf_usm_h%gamma_w_green_sat(kw,m) * psi_sat       &
+                                   / swc_sat_h(kw,m) ) * ( MAX( swc_h(kw,m),    &
+                                   wilt_h(kw,m) ) / swc_sat_h(kw,m) )**(        &
+                                   b_ch + 2.0_wp )
+
+!
+!--              Parametrization of Van Genuchten
+                 IF ( soil_type /= 7 )  THEN
+!
+!--                 Calculate the hydraulic conductivity after Van Genuchten 
+!--                 (1980)
+                    h_vg = ( ( (swc_res_h(kw,m) - swc_sat_h(kw,m)) / ( swc_res_h(kw,m) -    &
+                               MAX( swc_h(kw,m), wilt_h(kw,m) ) ) )**(      &
+                               surf_usm_h%n_vg_green(m) / (surf_usm_h%n_vg_green(m) - 1.0_wp ) ) - 1.0_wp  &
+                           )**( 1.0_wp / surf_usm_h%n_vg_green(m) ) / surf_usm_h%alpha_vg_green(m)
+
+
+                    gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( ( (1.0_wp +         &
+                                    ( surf_usm_h%alpha_vg_green(m) * h_vg )**surf_usm_h%n_vg_green(m))**(  &
+                                    1.0_wp - 1.0_wp / surf_usm_h%n_vg_green(m) ) - (        &
+                                    surf_usm_h%alpha_vg_green(m) * h_vg )**( surf_usm_h%n_vg_green(m)      &
+                                    - 1.0_wp) )**2 )                         &
+                                    / ( ( 1.0_wp + ( surf_usm_h%alpha_vg_green(m) * h_vg    &
+                                    )**surf_usm_h%n_vg_green(m) )**( ( 1.0_wp  - 1.0_wp     &
+                                    / surf_usm_h%n_vg_green(m) ) *( surf_usm_h%l_vg_green(m) + 2.0_wp) ) )
+
+!
+!--              Parametrization of Clapp & Hornberger
+                 ELSE
+                    gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( swc_h(kw,m)       &
+                                    / swc_sat_h(kw,m) )**(2.0_wp * b_ch + 3.0_wp)
+                 ENDIF
+
+              ENDDO
+
+!
+!--           Prognostic equation for soil moisture content. Only performed,
+!--           when humidity is enabled in the atmosphere
+              IF ( humidity )  THEN
+!
+!--              Calculate soil diffusivity (lambda_w) at the _stag level 
+!--              using linear interpolation. To do: replace this with
+!--              ECMWF-IFS Eq. 8.81
+                 DO  kw = nzb_wall, nzt_wall-1
+                   
+                    surf_usm_h%lambda_w_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) )  &
+                                      * 0.5_wp
+                    surf_usm_h%gamma_w_green(kw,m)  = ( gamma_green_temp(kw+1) + gamma_green_temp(kw) )    &
+                                      * 0.5_wp
+
+                 ENDDO
+
+!
+!--              In case of a closed bottom (= water content is conserved), 
+!--              set hydraulic conductivity to zero to that no water will be 
+!--              lost in the bottom layer.
+                 IF ( conserve_water_content )  THEN
+                    surf_usm_h%gamma_w_green(kw,m) = 0.0_wp
+                 ELSE
+                    surf_usm_h%gamma_w_green(kw,m) = gamma_green_temp(nzt_wall)
+                 ENDIF     
+
+!--              The root extraction (= root_extr * qsws_veg / (rho_l     
+!--              * l_v)) ensures the mass conservation for water. The         
+!--              transpiration of plants equals the cumulative withdrawals by 
+!--              the roots in the soil. The scheme takes into account the 
+!--              availability of water in the soil layers as well as the root 
+!--              fraction in the respective layer. Layer with moisture below 
+!--              wilting point will not contribute, which reflects the 
+!--              preference of plants to take water from moister layers.
+
+!
+!--              Calculate the root extraction (ECMWF 7.69, the sum of 
+!--              root_extr = 1). The energy balance solver guarantees a 
+!--              positive transpiration, so that there is no need for an 
+!--              additional check.
+                 m_total = 0.0_wp
+                 DO  kw = nzb_wall, nzt_wall
+                     IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
+                        m_total = m_total + rootfr_h(kw,m) * swc_h(kw,m)
+                     ENDIF
+                 ENDDO  
+
+                 IF ( m_total > 0.0_wp )  THEN
+                    DO  kw = nzb_wall, nzt_wall
+                       IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
+                          root_extr_green(kw) = rootfr_h(kw,m) * swc_h(kw,m)      &
+                                                          / m_total
+                       ELSE
+                          root_extr_green(kw) = 0.0_wp
+                       ENDIF
+                    ENDDO
+                 ENDIF
+
+!
+!--              Prognostic equation for soil water content m_soil.
+                 tend(:) = 0.0_wp
+
+                 tend(nzb_wall) = ( surf_usm_h%lambda_w_green(nzb_wall,m) * (            &
+                          swc_h(nzb_wall+1,m) - swc_h(nzb_wall,m) )    &
+                          * surf_usm_h%ddz_green(nzb_wall+1,m) - surf_usm_h%gamma_w_green(nzb_wall,m) - ( &
+                             root_extr_green(nzb_wall) * surf_usm_h%qsws_veg(m)          &
+!                                + surf_usm_h%qsws_soil_green(m)
+                                ) * drho_l_lv )             &
+                               * surf_usm_h%ddz_green_stag(nzb_wall,m)
+
+                 DO  kw = nzb_wall+1, nzt_wall-1
+                    tend(kw) = ( surf_usm_h%lambda_w_green(kw,m) * ( swc_h(kw+1,m)        &
+                              - swc_h(kw,m) ) * surf_usm_h%ddz_green(kw+1,m)              &
+                              - surf_usm_h%gamma_w_green(kw,m)                            &
+                              - surf_usm_h%lambda_w_green(kw-1,m) * (swc_h(kw,m) -        &
+                              swc_h(kw-1,m)) * surf_usm_h%ddz_green(kw,m)                 &
+                              + surf_usm_h%gamma_w_green(kw-1,m) - (root_extr_green(kw)   &
+                              * surf_usm_h%qsws_veg(m) * drho_l_lv)                       &
+                              ) * surf_usm_h%ddz_green_stag(kw,m)
+
+                 ENDDO
+                 tend(nzt_wall) = ( - surf_usm_h%gamma_w_green(nzt_wall,m)                  &
+                                         - surf_usm_h%lambda_w_green(nzt_wall-1,m)          &
+                                         * (swc_h(nzt_wall,m)             &
+                                         - swc_h(nzt_wall-1,m))           &
+                                         * surf_usm_h%ddz_green(nzt_wall,m)                 &
+                                         + surf_usm_h%gamma_w_green(nzt_wall-1,m) - (       &
+                                           root_extr_green(nzt_wall)               &
+                                         * surf_usm_h%qsws_veg(m) * drho_l_lv  )   &
+                                   ) * surf_usm_h%ddz_green_stag(nzt_wall,m)             
+
+                 swc_h_p(nzb_wall:nzt_wall,m) = swc_h(nzb_wall:nzt_wall,m)&
+                                                 + dt_3d * ( tsc(2) * tend(:)   &
+                                                 + tsc(3) * surf_usm_h%tswc_h_m(:,m) )   
+ 
+!
+!--              Account for dry soils (find a better solution here!)
+                 DO  kw = nzb_wall, nzt_wall
+                    IF ( swc_h_p(kw,m) < 0.0_wp )  swc_h_p(kw,m) = 0.0_wp
+                 ENDDO
+
+!
+!--              Calculate m_soil tendencies for the next Runge-Kutta step
+                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                    IF ( intermediate_timestep_count == 1 )  THEN
+                       DO  kw = nzb_wall, nzt_wall
+                          surf_usm_h%tswc_h_m(kw,m) = tend(kw)
+                       ENDDO
+                    ELSEIF ( intermediate_timestep_count <                   &
+                             intermediate_timestep_count_max )  THEN
+                       DO  kw = nzb_wall, nzt_wall
+                          surf_usm_h%tswc_h_m(kw,m) = -9.5625_wp * tend(kw) + 5.3125_wp&
+                                   * surf_usm_h%tswc_h_m(kw,m)
+                       ENDDO
+                    ENDIF
+                 ENDIF
+              ENDIF
+
+           ENDIF
+           
+        ENDDO
+
+!
+!--     For vertical surfaces     
+        DO  l = 0, 3                              
+           DO  m = 1, surf_usm_v(l)%ns
+
+              IF (surf_usm_v(l)%frac(ind_pav_green,m) > 0.0_wp) THEN
+!
+!-- no substrate layer for green walls / only groundbase green walls (ivy i.e.) -> green layers get same
+!-- temperature as first wall layer
+!-- there fore no temperature calculations for vertical green substrate layers now
+
+! 
+! !
+! !--              Obtain indices
+!                  i = surf_usm_v(l)%i(m)            
+!                  j = surf_usm_v(l)%j(m)
+!                  k = surf_usm_v(l)%k(m)
+!    
+!                  t_green_v(l)%t(nzt_wall+1,m) = t_wall_v(l)%t(nzb_wall,m)
+! !
+! !--              prognostic equation for green temperature t_green_v
+!                  gtend(:) = 0.0_wp
+!                  gtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_green(nzb_wall,m)) * &
+!                                          ( surf_usm_v(l)%lambda_h_green(nzb_wall,m) * &
+!                                            ( t_green_v(l)%t(nzb_wall+1,m)             &
+!                                            - t_green_v(l)%t(nzb_wall,m) ) *           &
+!                                            surf_usm_v(l)%ddz_green(nzb_wall+1,m)      &
+!                                          + surf_usm_v(l)%wghf_eb(m) ) *               &
+!                                            surf_usm_v(l)%ddz_green_stag(nzb_wall,m)
+!                
+!                  DO  kw = nzb_wall+1, nzt_wall
+!                     gtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_green(kw,m))          &
+!                               * (   surf_usm_v(l)%lambda_h_green(kw,m)              &
+!                                 * ( t_green_v(l)%t(kw+1,m) - t_green_v(l)%t(kw,m) ) &
+!                                 * surf_usm_v(l)%ddz_green(kw+1,m)                   &
+!                               - surf_usm_v(l)%lambda_h(kw-1,m)                      &
+!                                 * ( t_green_v(l)%t(kw,m) - t_green_v(l)%t(kw-1,m) ) &
+!                                 * surf_usm_v(l)%ddz_green(kw,m) )                   &
+!                               * surf_usm_v(l)%ddz_green_stag(kw,m)
+!                  ENDDO
+!    
+!                  t_green_v_p(l)%t(nzb_wall:nzt_wall,m) =                              &
+!                                       t_green_v(l)%t(nzb_wall:nzt_wall,m)             &
+!                                     + dt_3d * ( tsc(2)                                &
+!                                     * gtend(nzb_wall:nzt_wall) + tsc(3)               &
+!                                     * surf_usm_v(l)%tt_green_m(nzb_wall:nzt_wall,m) )   
+!    
+! !
+! !--              calculate t_green tendencies for the next Runge-Kutta step
+!                  IF ( timestep_scheme(1:5) == 'runge' )  THEN
+!                      IF ( intermediate_timestep_count == 1 )  THEN
+!                         DO  kw = nzb_wall, nzt_wall
+!                            surf_usm_v(l)%tt_green_m(kw,m) = gtend(kw)
+!                         ENDDO
+!                      ELSEIF ( intermediate_timestep_count <                           &
+!                               intermediate_timestep_count_max )  THEN
+!                          DO  kw = nzb_wall, nzt_wall
+!                             surf_usm_v(l)%tt_green_m(kw,m) =                          &
+!                                         - 9.5625_wp * gtend(kw) +                     &
+!                                           5.3125_wp * surf_usm_v(l)%tt_green_m(kw,m)
+!                          ENDDO
+!                      ENDIF
+!                  ENDIF
+
+                 DO  kw = nzb_wall, nzt_wall+1
+                     t_green_v(l)%t(kw,m) = t_wall_v(l)%t(nzb_wall,m)
+                 ENDDO
               
-ENDIF
+              ENDIF
 
            ENDDO
